<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
  <title>PHP ukzky</title>
  <meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
</head>

<body>
<?php
  include "db.php";
  echo_index_link();

  if( array_key_exists("smazat",$_REQUEST) )
  {
    wb_exec($conn, "DELETE FROM Datetime;");
  }
  elseif( array_key_exists("vlozit",$_REQUEST) )
  {
    // zadane udaje ulozime do lokalnich promennych, abychom se na ne mohli odkazovat z sql prikazu, resp. vkladat je do textu SQL prikazu
    $datum=$_REQUEST["datum"];
    $cas=$_REQUEST["cas"];
    $ts=$_REQUEST["timestamp"];
    if( $_REQUEST["zpusob"]=="text" )
    {
      wb_exec($conn, "INSERT INTO Datetime(datum,cas,`timestamp`) VALUES ($datum,$cas,$ts);");
    }
    else
    {
      /* nastavime konfiguracni udaj wb_datestring na "1", aby PHP modul
       * provadel konverzi host promennych typu string, ktere obsahuji
       * syntakticky spravne (dle jazyka SQL v 602SQL) zapsane konstanty
       * typu DATE, TIME, nebo TIMESTAMP na hodnoty odpovidajiciho typu */
      ini_set("wb_datestring","1");
      // provedeme SQL prikaz
      wb_exec($conn, "INSERT INTO Datetime(datum,cas,`timestamp`) VALUES (:<datum,:<cas,:<ts);");
    }
  }
?>
<h1>Manipulace s daji typu DATE, TIME a TIMESTAMP</h1>
Tabulka <code>Datetime</code> obsahuje sloupec <code>datum</code> typu DATE, <code>cas</code> typu TIME a <code>timestamp</code> typu TIMESTAMP.

<h3>Zobrazen daj z databze</h3>
daje typu TIME a DATE se do PHP petou jako etzce, daj typu TIMESTAMP se pete jako cel slo udvajc poet sekund od Unix Epoch do asovho okamiku, kter je pedstavovn tmto dajem (hodnota NULL PHP hodnotou NULL a asov okamik, kter nelze tmto zpsobem vyjdit (jakkoliv as ped Unix Epoch), hodnotou -1). Kterkoliv daj lze tak zkonvertovat na etzec jet na SQL serveru, pi vyhodnocovn SQL pkazu SELECT - viz daj <code>timestamp_str</code> zskan konverz <code>CAST(`timestamp` AS CHAR(40))</code>.
<ul>
<?php
  $res=wb_exec($conn, "select datum,cas,`timestamp`,CAST(`timestamp` AS CHAR(40)) AS timestamp_str from Datetime");
  while(wb_fetch_into($res, $foo)){
    echo "<li>datum: ";
    if( is_null($foo[1]) ) echo "NULL"; else echo $foo[1];
    echo "<br>cas: ";
    if( is_null($foo[2]) ) echo "NULL"; else echo $foo[2];
    echo "<br>timestamp: ";
    if( is_null($foo[3]) ) echo "NULL"; else echo $foo[3];
    echo "<br>timestamp po konverzi pomoc date(): ";
    if( is_null($foo[3]) ) echo "NULL"; else echo date("D M j G:i:s Y",$foo[3]);
    echo "<br>timestamp_str: $foo[4]";
    echo "</li>\n";
  }
?>
</ul>
V tabulce <tt>Datetime</tt> je celkem <?php echo wb_num_rows($res); ?> zznam.

<h3>Vkldn daj do databze</h3>
<form method="post" action="datetime.php">
Existuj dv monosti, jak vloit daj datumovho, i asovho typu do databze:
<blockquote>
<input type="radio" name="zpusob" value="text" checked> Sestavenm zdrojovho textu SQL pkazu, kter bude pmo (textov) obsahovat daj, kter chceme do databze vloit. V tomto ppad je teba daje zadvat v tom tvaru, kter oekv SQL server, tj. podle pravidel jazyka SQL pro konstanty typu DATE, TIME, resp. TIMESTAMP (viz Npovda 602SQL: Jazyk SQL -&gt; Lexikln elementy -&gt; Zpis asu a data).<br>
<input type="radio" name="zpusob" value="host"> Pomoc host promnnch, tj. daj, kter chceme vloit do databze, bude v PHP promnn a tuto promnnou uvedeme v SQL pkazu pomoc konstrukce <code>:&lt;jmno_promnn</code> . Tmto zpsobem nelze vloit NULL hodnotu, protoe PHP modul neme z PHP hodnoty NULL zjistit, jakho SQL typu je tato NULL hodnota (SQL server toti vdy vyaduje uren typu hodnoty).
</blockquote>
Vyberte, kterm zpsobem budou daje vloeny do databze, zadejte daje (pokud chcete zadat NULL, napite <code>NULL</code>, ale pouze pi vkldn prvnm zpsobem) a stisknte tlatko:<br>
datum: <input type="text" name="datum"><br>
cas: <input type="text" name="cas"><br>
timestamp: <input type="text" name="timestamp"> (m smysl zadvat datum a as od 1.1.1900 - viz rozsah typu TIMESTAMP popsan v dokumentaci k 602SQL)<br>
<input type="submit" name="vlozit" value="Vloit do databze">
</form>

<h3>Smazn vech zznam z tabulky Datetime</h3>
<form method="post" action="datetime.php">
Ze servisnch dvod mete <input type="submit" name="smazat" value="smazat vechny zznamy"> z tabulky Datetime.
</form>

</body>
</html>

