<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"
                      "http://www.w3.org/TR/html4/loose.dtd">
<html>
 <head>
  <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
  <title>UNICODE stringy v 602SQL</title>
 </head>
 <body>
   <?php
     include "db.php";

     if( array_key_exists("vlozit",$_REQUEST) )
     {
       // vlozeni zaznamu do tabulky
       // ulozime zadane texty do lokalnich promennych, abychom se na ne mohli odkazovat z SQL prikazu
       $uni_string=$_REQUEST["uni_string"];
       $uni_text=$_REQUEST["uni_text"];
       // nejdrive nastavime kodovani textu, ktere budeme vkladat
       // texty se zadavaji ve formulari, ktery je v HTML strance, ktera pouziva kodovani UTF-8 => zadane texty jsou v kodovani UTF-8
       wb_set_client_encoding($conn,WB_ENC_UTF8);
       // nyni vytvorime novy zaznam
       wb_exec($conn,"INSERT INTO Uni_table(uni_string,uni_clob) VALUES(:<uni_string,:<uni_text);");
     }
     elseif( array_key_exists("smazat",$_REQUEST) )
     {
       wb_exec($conn,"DELETE FROM Uni_table;");
     }

     echo_index_link();
   ?>
   <h1>Příklad v UNICODE</h1>

   Hodnoty sloupců typu NCHAR a NCLOB se v 602SQL ukládají v UNICODE (konkrétně v kódování UCS-2). php_602sql je při čtení automaticky překonvertuje do kódování UTF-8, se kterým se v PHP i na webu snadněji pracuje.
   <p>
   <b>Příklad:</b> zobrazení obsahu tabulky Uni_table s UNICODE sloupcemi Uni_string typu NCHAR a Uni_clob typu NCLOB
   <p>
   <?php
     // precist zaznamy
     $res=wb_exec($conn,"SELECT uni_string,uni_clob FROM Uni_table");
     // zobrazit je
     echo "<ul>";
     while( wb_fetch_row($res) )
     {
       echo "<li>";
       echo "Uni_string: \"".wb_result($res,1)."\"<br>\n";
       echo "Uni_clob: ".wb_result($res,2)."\n";
     }
     echo "</ul>";
   ?>
   <hr>
   UNICODE texty lze také vkládat do databáze. Aby byly správně uloženy, musíme sdělit php_602sql, v jakém kódování jsou texty, které chceme zapsat do databáze. K tomu slouží funkce <code>wb_set_client_encoding</code> (stačí ji zavolat předtím, než SQL příkazem vložíme texty do databáze).
   <form method="POST" action="unicode.php">
   Tímto formulářem vložíte nový záznam do tabulky Uni_table.<br>
   uni_string: <input type="text" size="100" name="uni_string"><br>
   uni_text: <textarea name="uni_text"></textarea><br>
   <input type="submit" name="vlozit" value="Vložit nový záznam">
   </form>
   <hr>
   <form method="POST" action="unicode.php">
   Ze servisních důvodů můžete také všechny záznamy z tabulky Uni_table smazat.
   <input type="submit" name="smazat" value="Smazat všechny záznamy">
   </form>
 </body>
</html>

