<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
  <title>PHP ukzky</title>
  <meta http-equiv="Content-Type" content="text/html; charset=windows-1250">
</head>

<body>
<?php
  include "db.php";
  echo_index_link();

  function wb_tables($conn)
  {
    return wb_exec($conn,
      "select tab_name AS TABLE_NAME, defin
	  from tabtab, objtab
	  where tabtab.apl_uuid=objtab.apl_uuid
		  AND obj_name=current_application
		  AND ord(objtab.category)=CATEG_APPL");
  }

  function wb_procedures($conn)
  {
    return wb_exec($conn,
      "select objtab1.obj_name AS PROCEDURE_NAME, objtab1.defin
	  from objtab objtab1, objtab
	  where objtab1.apl_uuid=objtab.apl_uuid
		  AND objtab.obj_name=current_application
		  AND ord(objtab.category)=CATEG_APPL
		  AND ord(objtab1.category)=CATEG_PROC");
  }

  /* Tato funkce me mt jeden nebo dva parametry */
  function wb_procedurecolumns($conn)
  {
    if (func_num_args()==2)
    {
      $sql="select * from _iv_procedure_parameters
		     where schema_name=current_application
		    AND Procedure_name='".func_get_arg(1)."'";
    }
    else
    {
      $sql="select * from _iv_procedure_parameters
		     where schema_name=current_application";
    }
    return wb_exec($conn, $sql);
  }
?>

<h1>Seznam tabulek a procedur v aplikaci</h1>
<p>ODBC rozhran definuje funkce pro zskvn informac o tabulkch a
uloench procedurch. Potebn informace lze zskat pomoc systmovch
informanch dotaz v SQL. Zde jsou definovny v PHP a pouity
jednoduch (skoro) ekvivalenty tchto chybjcch funkc.
<?
	wb_binmode(0, WB_RETURN);
	wb_longreadlen(0, 64);
?>
<p>Definovny jsou ti procedury; prvn vrac tabulku se seznamem tabulek v
aplikaci. Pro pehlednost jsou ve vstupu zkrceny definice na ticet znak.
<?
	$res=wb_tables($conn);
	wb_result_all($res, "border=2");
?>
<p>Dal procedura vype seznam SQL procedur dan aplikace.
<?
	$res=wb_procedures($conn);
	wb_result_all($res, "border=2");
?>
<p>A konen posledn procedura vype seznam parametr procedur. Tato
procedura byla napsna tak, e me mt jeden nebo dva parametry - krom
odkazu na spojen jet jmno procedury; pokud nen uvedeno, zobraz se
vechny parametry vech procedur.
<?
	$res=wb_procedurecolumns($conn, "test");
	wb_result_all($res, "border=2");
?>
<br>
</body>
</html>

